#include "xtypewatch.h"
#include "dangermeter.hh"

void
DangerMeter::drawLevel(float lvl)
{   
    used(int(lvl*100/ danger_));

    fields_[0] = (lvl > danger_)? danger_ : lvl;
    float red = (lvl > danger_)? lvl - danger_ : 0.0;

    if (red + fields_[0]> total_)
	red = total_ - fields_[0];

    fields_[1]=red;
    fields_[2] = total_ - fields_[0]-fields_[1];     
    

    drawfields();
}

void
DangerMeter::tryWarn(float lvl)
{
    if (lvl > danger_)
	if (!warned_){
	    parent_->warn();
	    warned_=true;
	} else
	    ;
    else
	warned_ = false;
}

DangerMeter::DangerMeter(XTypeWatch *parent, int x, int y, int width,
			 int height, const char *tit,  const char *leg)
    : FieldMeter(parent, x,y,width, height, 3, tit, leg) 
{
    warned_ = false;
    danger_ = 1;
    max_ =2;

    parent_->addResource( "normalColor", NULL, "yellow" );
    parent_->addResource( "dangerColor", NULL, "red" );
    parent_->addResource( "okColor", NULL, "navy" );
}

void DangerMeter::checkResources( void )
{
    FieldMeter::checkResources();

    setfieldcolor( 0, parent_->getResource( "normalColor" ) );
    setfieldcolor( 1, parent_->getResource( "dangerColor" ) );
    setfieldcolor( 2, parent_->getResource( "okColor" ) );
}
